#include "dav.h"


static unsigned char _v21[] = { 0x01, 0x01 };

static Password_Name _v22 = {
        {
            2,
            {
                0x11, 0x22
            }
        },
        {
            2,
            {
                0x33, 0x44
            }
        }
    };

static struct _seqof25 _v20[] = {
    {NULL, {ROS_invoke_chosen}}
};

H4501SupplementaryService pdu = {
    0,
    {0},
    {0},
    {rosApdus_chosen}
};


int main(int argc, char **argv)
{
    OssGlobal www, *world = &www;
    long      pdu_num;
    int       rc = 0;
    OssBuf encodedData;
    void *decodedPDU, *buf;


    _v20[0].value.u.invoke.opcode.u.global.length = 2;
    _v20[0].value.u.invoke.opcode.u.global.value = _v21;
    _v20[0].value.u.invoke.bit_mask = argument_present;
    _v20[0].value.u.invoke.invokeId = 1;
    _v20[0].value.u.invoke.opcode.choice = global_chosen;
    _v20[0].value.u.invoke.argument.pduNum = 29;
	/* _v20[0].value.u.invoke.argument.decoded = &_v22; -compat v8.7.0 */
    _v20[0].value.u.invoke.argument.decoded.pdu_Password_Name = &_v22;
    pdu.serviceApdu.u.rosApdus = _v20;

    rc = ossinit(world, dav);
    if (rc) {
	printf("%d was returned by ossinit().\n", rc);
	return rc? EXIT_FAILURE : EXIT_SUCCESS;
    }
    ossSetFlags(world, DEBUGPDU|AUTOMATIC_ENCDEC);
    encodedData.value = NULL;
    encodedData.length = 0;

    ossPrint(world, "\tUnencoded PDU...\n\n");
    ossPrintPDU(world, H4501SupplementaryService_PDU, &pdu);
    
    ossPrint(world, "\n\tEncoding the PDU...\n\n");
    if (ossEncode(world, H4501SupplementaryService_PDU, &pdu, &encodedData)) {
        ossPrint(world, "%s\n", ossGetErrMsg(world));
	ossterm(world);
        return 1;
    }
    else {
	buf = (char *)encodedData.value;

        ossPrint(world, "\n\tEncoded PDU...\n\n");
	ossPrintHex(world, encodedData.value, encodedData.length);

        ossPrint(world, "\n\tDecoding the PDU...\n\n");
	decodedPDU = NULL;
	pdu_num = H4501SupplementaryService_PDU;
        if (ossDecode(world, &pdu_num, &encodedData, &decodedPDU)) {
            ossPrint(world, "%s\n", ossGetErrMsg(world));  /* an error occurred, print errmsg */
	    ossterm(world);
            rc = 1;
        }
        else {
            ossPrint(world, "\n\tDecoded PDU...\n\n");
	    ossPrintPDU(world, pdu_num, decodedPDU);
	    ossFreePDU(world, pdu_num, decodedPDU);
            rc = 0;
        }

	ossFreeBuf(world, buf);
	ossterm(world);
	return rc;
    }
    ossterm(world);
    return rc? EXIT_FAILURE: EXIT_SUCCESS;
}






